'use strict';

Object.defineProperty(exports, "__esModule", {
  value: true
});

var _createClass = function () { function defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } } return function (Constructor, protoProps, staticProps) { if (protoProps) defineProperties(Constructor.prototype, protoProps); if (staticProps) defineProperties(Constructor, staticProps); return Constructor; }; }();

var _events = require('events');

var _event = require('./event');

var _event2 = _interopRequireDefault(_event);

var _constants = require('./constants');

var _utils = require('./utils');

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { default: obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

var IpcRenderer = function () {
  function IpcRenderer(pipe) {
    _classCallCheck(this, IpcRenderer);

    this._emitter = new _events.EventEmitter();

    this._emitter.on(_constants.UNIQUE + '-receive', this._onReceiveFromMain.bind(this));

    this.IS_MOCK = true;
  }

  _createClass(IpcRenderer, [{
    key: 'send',
    value: function send(channel) {
      var _emitter;

      for (var _len = arguments.length, args = Array(_len > 1 ? _len - 1 : 0), _key = 1; _key < _len; _key++) {
        args[_key - 1] = arguments[_key];
      }

      (_emitter = this._emitter).emit.apply(_emitter, [_constants.UNIQUE + '-send', channel].concat(args));
    }

    // Not yet implemented

  }, {
    key: 'sendSync',
    value: function sendSync(channel) {}

    // Not yet implemented

  }, {
    key: 'sendToHost',
    value: function sendToHost(channel) {}
  }, {
    key: '_onReceiveFromMain',
    value: function _onReceiveFromMain(channel) {
      var _emitter2;

      var e = new _event2.default(this._emitter);

      for (var _len2 = arguments.length, args = Array(_len2 > 1 ? _len2 - 1 : 0), _key2 = 1; _key2 < _len2; _key2++) {
        args[_key2 - 1] = arguments[_key2];
      }

      (_emitter2 = this._emitter).emit.apply(_emitter2, [channel, e].concat(args));
    }

    /**
     * Proxy all the EventEmitter methods defined in the IpcRenderer API.
     */

  }, {
    key: 'on',
    value: function on() {
      var _emitter3;

      (_emitter3 = this._emitter).on.apply(_emitter3, arguments);
    }
  }, {
    key: 'once',
    value: function once() {
      var _emitter4;

      (_emitter4 = this._emitter).once.apply(_emitter4, arguments);
    }
  }, {
    key: 'removeListener',
    value: function removeListener() {
      var _emitter5;

      (_emitter5 = this._emitter).removeListener.apply(_emitter5, arguments);
    }
  }, {
    key: 'removeAllListeners',
    value: function removeAllListeners() {
      if (arguments.length === 0) {
        // if removing all event listeners, don't clobber proxy events
        (0, _utils.removeNonProxyEvents)(this._emitter);
      } else {
        var _emitter6;

        (_emitter6 = this._emitter).removeAllListeners.apply(_emitter6, arguments);
      }
    }
  }]);

  return IpcRenderer;
}();

exports.default = IpcRenderer;